
#property copyright "Copyright  2009, Forex_System"
#property link      ""

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Salmon
#property indicator_color4 LightGreen

extern int Minutes = 5;
int gi_80 = 13;
int gi_84 = 6;
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double gda_104[];
double g_iadx_108;
double g_iadx_116;
string gs_124;
double gd_132;
double g_ilow_140 = 0.0;
double g_ihigh_148 = 0.0;
double gd_156 = 0.0;
double gd_164 = 0.0;
double gd_unused_172 = 0.0;
double gd_180 = 0.0;
double gd_188 = 0.0;
double gd_196 = 0.0;

int init() {
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 5);
   SetIndexBuffer(0, g_ibuf_88);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 5);
   SetIndexBuffer(1, g_ibuf_92);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(2, g_ibuf_96);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(3, g_ibuf_100);
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   SetIndexLabel(3, NULL);
   SetIndexLabel(4, NULL);
   switch (Minutes) {
   case 1:
      gs_124 = "Period_M1";
      break;
   case 5:
      gs_124 = "Period_M5";
      break;
   case 15:
      gs_124 = "Period_M15";
      break;
   case 30:
      gs_124 = "Period_M30";
      break;
   case 60:
      gs_124 = "Period_H1";
      break;
   case 240:
      gs_124 = "Period_H4";
      break;
   case 1440:
      gs_124 = "Period_D1";
      break;
   case 10080:
      gs_124 = "Period_W1";
      break;
   case 43200:
      gs_124 = "Period_MN1";
      break;
   default:
      gs_124 = "Current Timeframe";
      Minutes = 0;
   }
   IndicatorShortName("Forex_System Multi-Trend (" + gs_124 + ")");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_ind_counted_0 = IndicatorCounted();
   for (int li_4 = 800; li_4 > -1; li_4--) {
      g_ibuf_88[li_4] = 0;
      g_ibuf_92[li_4] = 0;
      g_ibuf_96[li_4] = 0;
      g_ibuf_100[li_4] = 0;
      gda_104[li_4] = 0;
      g_iadx_108 = iADX(NULL, Minutes, 14, PRICE_CLOSE, MODE_PLUSDI, li_4);
      g_iadx_116 = iADX(NULL, Minutes, 14, PRICE_CLOSE, MODE_MINUSDI, li_4);
      g_ihigh_148 = iHigh(NULL, Minutes, iHighest(NULL, Minutes, MODE_HIGH, gi_80, li_4));
      g_ilow_140 = iLow(NULL, Minutes, iLowest(NULL, Minutes, MODE_LOW, gi_80, li_4));
      gd_132 = (iHigh(NULL, Minutes, li_4) + iLow(NULL, Minutes, li_4)) / 2.0;
      if (gi_84 == 1) gd_132 = iOpen(NULL, Minutes, li_4);
      if (gi_84 == 2) gd_132 = iClose(NULL, Minutes, li_4);
      if (gi_84 == 3) gd_132 = iHigh(NULL, Minutes, li_4);
      if (gi_84 == 4) gd_132 = iLow(NULL, Minutes, li_4);
      if (gi_84 == 5) gd_132 = (iHigh(NULL, Minutes, li_4) + iLow(NULL, Minutes, li_4) + iClose(NULL, Minutes, li_4)) / 3.0;
      if (gi_84 == 6) gd_132 = (iOpen(NULL, Minutes, li_4) + iHigh(NULL, Minutes, li_4) + iLow(NULL, Minutes, li_4) + iClose(NULL, Minutes, li_4)) / 4.0;
      if (gi_84 == 7) gd_132 = (iOpen(NULL, Minutes, li_4) + iClose(NULL, Minutes, li_4)) / 2.0;
      gd_156 = 0.66 * ((gd_132 - g_ilow_140) / (g_ihigh_148 - g_ilow_140) - 0.5) + 0.67 * gd_164;
      gd_156 = MathMin(MathMax(gd_156, -0.999), 0.999);
      gd_180 = MathLog((gd_156 + 1.0) / (1 - gd_156)) / 2.0 - gd_188 / 2.0 - gd_196 / 2.0;
      if (gd_180 > 0.0 && g_iadx_108 > g_iadx_116) g_ibuf_92[li_4] = 1;
      if (gd_180 > 0.0 && g_iadx_116 > g_iadx_108) g_ibuf_100[li_4] = 1;
      if (gd_180 < 0.0 && g_iadx_116 > g_iadx_108) g_ibuf_88[li_4] = 1;
      if (gd_180 < 0.0 && g_iadx_108 > g_iadx_116) g_ibuf_96[li_4] = 1;
      if (g_ibuf_88[li_4] == 0.0 && g_ibuf_92[li_4] == 0.0) {
      }
      if (gd_180 == 0.0 && g_iadx_108 > g_iadx_116) g_ibuf_92[li_4] = 1;
      if (gd_180 == 0.0 && g_iadx_108 < g_iadx_116) g_ibuf_88[li_4] = 1;
      gd_164 = gd_156;
      gd_196 = gd_188;
      gd_188 = gd_180;
   }
   return (0);
}